# all files / ol/source/ zoomifysource.js

96.05% Statements 73/76
91.3% Branches 21/23
100% Functions 4/4
96.05% Lines 73/76

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163
    164
    165
    166
    167
    168
    169
    170
    171
    172
    173
    174
    175
    176
    177
    178
    179
    180
    181
    182
    183
    184
    185
    186
    187
    188
    1891×

    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×

    1×

    1×

    24×

    24×
    24×

    24×
    21×
    21×
    21×

    21×

    18×
    30×

    30×

    18×

    2×
    2×
    2×
    1×

    1×
    1×

    2×

    1×

    20×
    20×

    20×
    20×
    20×
    20×
    31×
    31×

    20×

    20×
    20×

    20×

    1×
    11×
    1×

    10×
    10×
    10×
    10×

    10×
    10×

    20×

    1×

    1×

    5×

    5×

    1×

    1×
    7×
    7×

    7×
    1×

    6×
    6×
    1×

    1×
    1×
    1×
    1×

    5×

     goog.provide('ol.source.Zoomify');

    goog.require('goog.asserts');
    goog.require('ol');
    goog.require('ol.ImageTile');
    goog.require('ol.TileCoord');
    goog.require('ol.TileState');
    goog.require('ol.dom');
    goog.require('ol.extent');
    goog.require('ol.proj');
    goog.require('ol.source.TileImage');
    goog.require('ol.tilegrid.TileGrid');

    /**
     * @enum {string}
     */
    ol.source.ZoomifyTierSizeCalculation = {
      DEFAULT: 'default',
      TRUNCATED: 'truncated'
    };

    /**
     * @classdesc
     * Layer source for tile data in Zoomify format.
     *
     * @constructor
     * @extends {ol.source.TileImage}
     * @param {olx.source.ZoomifyOptions=} opt_options Options.
     * @api stable
     */
    ol.source.Zoomify = function(opt_options) {

      var options = opt_options || {};

      var size = options.size;
      var tierSizeCalculation = options.tierSizeCalculation !== undefined ?
          options.tierSizeCalculation :
          ol.source.ZoomifyTierSizeCalculation.DEFAULT;

      var imageWidth = size[0];
      var imageHeight = size[1];
      var tierSizeInTiles = [];
      var tileSize = ol.DEFAULT_TILE_SIZE;

      switch (tierSizeCalculation) {
        case ol.source.ZoomifyTierSizeCalculation.DEFAULT:
          while (imageWidth > tileSize || imageHeight > tileSize) {
            tierSizeInTiles.push([
              Math.ceil(imageWidth / tileSize),
              Math.ceil(imageHeight / tileSize)
            ]);
            tileSize += tileSize;
          }
          break;
        case ol.source.ZoomifyTierSizeCalculation.TRUNCATED:
          var width = imageWidth;
          var height = imageHeight;
          while (width > tileSize || height > tileSize) {
            tierSizeInTiles.push([
              Math.ceil(width / tileSize),
              Math.ceil(height / tileSize)
            ]);
            width >>= 1;
            height >>= 1;
          }
          break;
        default:
          goog.asserts.fail();
          break;
      }

      tierSizeInTiles.push([1, 1]);
      tierSizeInTiles.reverse();

      var resolutions = [1];
      var tileCountUpToTier = [0];
      var i, ii;
      for (i = 1, ii = tierSizeInTiles.length; i < ii; i++) {
        resolutions.push(1 << i);
        tileCountUpToTier.push(
            tierSizeInTiles[i - 1][0] * tierSizeInTiles[i - 1][1] +
            tileCountUpToTier[i - 1]
        );
      }
      resolutions.reverse();

      var extent = [0, -size[1], size[0], 0];
      var tileGrid = new ol.tilegrid.TileGrid({
        extent: extent,
        origin: ol.extent.getTopLeft(extent),
        resolutions: resolutions
      });

      var url = options.url;

      /**
       * @this {ol.source.TileImage}
       * @param {ol.TileCoord} tileCoord Tile Coordinate.
       * @param {number} pixelRatio Pixel ratio.
       * @param {ol.proj.Projection} projection Projection.
       * @return {string|undefined} Tile URL.
       */
      function tileUrlFunction(tileCoord, pixelRatio, projection) {
        if (!tileCoord) {
          return undefined;
        } else {
          var tileCoordZ = tileCoord[0];
          var tileCoordX = tileCoord[1];
          var tileCoordY = -tileCoord[2] - 1;
          var tileIndex =
              tileCoordX +
              tileCoordY * tierSizeInTiles[tileCoordZ][0] +
              tileCountUpToTier[tileCoordZ];
          var tileGroup = (tileIndex / ol.DEFAULT_TILE_SIZE) | 0;
          return url + 'TileGroup' + tileGroup + '/' +
              tileCoordZ + '-' + tileCoordX + '-' + tileCoordY + '.jpg';
        }
      }

      goog.base(this, {
        attributions: options.attributions,
        cacheSize: options.cacheSize,
        crossOrigin: options.crossOrigin,
        logo: options.logo,
        reprojectionErrorThreshold: options.reprojectionErrorThreshold,
        tileClass: ol.source.ZoomifyTile_,
        tileGrid: tileGrid,
        tileUrlFunction: tileUrlFunction
      });

    };
    goog.inherits(ol.source.Zoomify, ol.source.TileImage);

    /**
     * @constructor
     * @extends {ol.ImageTile}
     * @param {ol.TileCoord} tileCoord Tile coordinate.
     * @param {ol.TileState} state State.
     * @param {string} src Image source URI.
     * @param {?string} crossOrigin Cross origin.
     * @param {ol.TileLoadFunctionType} tileLoadFunction Tile load function.
     * @private
     */
    ol.source.ZoomifyTile_ = function(
        tileCoord, state, src, crossOrigin, tileLoadFunction) {

      goog.base(this, tileCoord, state, src, crossOrigin, tileLoadFunction);

      /**
       * @private
       * @type {Object.<string,
       *                HTMLCanvasElement|HTMLImageElement|HTMLVideoElement>}
       */
      this.zoomifyImageByContext_ = {};

    };
    goog.inherits(ol.source.ZoomifyTile_, ol.ImageTile);

    /**
     * @inheritDoc
     */
    ol.source.ZoomifyTile_.prototype.getImage = function(opt_context) {
      var tileSize = ol.DEFAULT_TILE_SIZE;
      var key = opt_context !== undefined ?
          goog.getUid(opt_context).toString() : '';
      if (key in this.zoomifyImageByContext_) {
        return this.zoomifyImageByContext_[key];
      } else {
        var image = goog.base(this, 'getImage', opt_context);
        if (this.state == ol.TileState.LOADED) {
          Iif (image.width == tileSize && image.height == tileSize) {
            this.zoomifyImageByContext_[key] = image;
            return image;
          } else {
            var context = ol.dom.createCanvasContext2D(tileSize, tileSize);
            context.drawImage(image, 0, 0);
            this.zoomifyImageByContext_[key] = context.canvas;
            return context.canvas;
          }
        } else {
          return image;
        }
      }
    };